--- wine-current/dlls/msvcrt/wcs.c	2005-05-28 10:23:21.000000000 -0700
+++ wine-20050528/dlls/msvcrt/wcs.c	2005-06-06 06:05:00.000000000 -0700
@@ -384,6 +384,16 @@
         sprintf(p, ".%d", flags->Precision);
         p += strlen(p);
     }
+    if( flags->IntegerLength == 'I' )
+    {
+        *p = 'l';
+        p++;
+    }
+    if( flags->IntegerDouble )
+    {
+        *p = 'l';
+        p++;
+    }
     *p++ = flags->Format;
     *p++ = 0;
 }
@@ -485,7 +495,7 @@
         /* deal with integer width modifier */
         while( *p )
         {
-            if( *p == 'h' || *p == 'l' || *p == 'L' )
+            if( *p == 'h' || *p == 'I' || *p == 'l' || *p == 'L' )
             {
                 if( flags.IntegerLength == *p )  /* FIXME: this is wrong */
                     flags.IntegerDouble++;
@@ -501,6 +511,26 @@
                 break;
         }
 
+        /* If %I is our integer length specifier, check for a requested size */
+	if ( flags.IntegerLength == 'I' && isdigit(*p) )
+        {
+            if( p[0] == '3' && p[1] == '2' )
+            {
+                p += 2;
+            }
+            else if( p[0] == '6' && p[1] == '4' )
+            {
+                flags.IntegerDouble++;
+                p += 2;
+            }
+            else
+            {
+                /* If any other number follows, it breaks the conversion */
+                p = q+1;
+                continue;
+            }
+        }
+
         flags.Format = *p;
         r = 0;
 
@@ -582,6 +612,8 @@
 
             if( pf_is_double_format( flags.Format ) )
                 sprintf( number, fmt, va_arg(valist, double) );
+            else if ( flags.IntegerDouble )
+                sprintf( number, fmt, va_arg(valist, long long) );
             else
                 sprintf( number, fmt, va_arg(valist, int) );
 
